require('game/creatures/Animal');
require('game/managers/Creature');
require('engine/core/MVCommons');

Creatures.Duck = MVC.deepClone(Creatures.Animal);

(function($){
  $.creatureName = 'duck';
  $.creatureKindName = 'duck';
  $.creatureKindEnabled = true;

  $._spriteName = 'animals/ducks';
  $._spriteIndex = 0;

  $._hitboxX = 0;
  $._hitboxY = 0;
  $._hitboxWidth = 32;
  $._hitboxHeight = 32;
  $._offsetX = 0;
  $._offsetY = 0;

  $._price = 2000;

  $.isDuck = true;

  $.processCreatureNewDay = function(creature) {
    // if (!CoopMap.consumeAnimalFoodInMap(creature.mapId)) {
    //   if (!Managers.Map.mapIsFarm(creature.mapId)) {
    //     creature.friendship -= 10;
    //     return;
    //   }

    //   //Ducks love rain
    //   if (Managers.Weather.isBadWeather() || Managers.Weather.wasBadWeather()) {
    //     creature.friendship += 5;
    //   }

    //   creature.friendship += 2;
    //   if (Math.random() * 5 < creature._duckLuck) {
    //     creature._duckSpeed += 0.01;
    //   }
    // }

    // creature.friendship += 1;
    // Managers.FarmObjects.createItemAt(creature.mapId, creature.x, creature.y, 'duck-egg', 1);
  };

  $.processNewCreatureInstance = function(creature) {
  };

  $.increaseFriendshipForBeingOutside = function() {
    if (Managers.Weather.isRaining()) {
      this.friendship += 0.02;
    } else if (Managers.Weather.isBadWeather()) {
      this.friendship -= 10;
    } else {
      this.friendship += 0.005;
    }
  };
})(Creatures.Duck);

Creatures.Duck2 = MVC.deepClone(Creatures.Duck);
Creatures.Duck3 = MVC.deepClone(Creatures.Duck);
Creatures.Duck4 = MVC.deepClone(Creatures.Duck);
Creatures.Duck5 = MVC.deepClone(Creatures.Duck);
Creatures.Duck6 = MVC.deepClone(Creatures.Duck);
Creatures.Duck7 = MVC.deepClone(Creatures.Duck);
Creatures.Duck8 = MVC.deepClone(Creatures.Duck);

Creatures.Duck2.creatureName = 'duck2';
Creatures.Duck2._spriteIndex = 1;

Creatures.Duck3.creatureName = 'duck3';
Creatures.Duck3._spriteIndex = 2;

Creatures.Duck4.creatureName = 'duck4';
Creatures.Duck4._spriteIndex = 3;

Creatures.Duck5.creatureName = 'duck5';
Creatures.Duck5._spriteIndex = 4;

Creatures.Duck6.creatureName = 'duck6';
Creatures.Duck6._spriteIndex = 5;

Creatures.Duck7.creatureName = 'duck7';
Creatures.Duck7._spriteIndex = 6;

Creatures.Duck8.creatureName = 'duck8';
Creatures.Duck8._spriteIndex = 7;

Managers.Creatures.registerCreature(Creatures.Duck);
Managers.Creatures.registerCreature(Creatures.Duck2);
Managers.Creatures.registerCreature(Creatures.Duck3);
Managers.Creatures.registerCreature(Creatures.Duck4);
Managers.Creatures.registerCreature(Creatures.Duck5);
Managers.Creatures.registerCreature(Creatures.Duck6);
Managers.Creatures.registerCreature(Creatures.Duck7);
Managers.Creatures.registerCreature(Creatures.Duck8);